# Vue Calendars Components

The [Vue Calendars](https://www.syncfusion.com/vue-components/vue-calendar?utm_source=npm&utm_medium=listing&utm_campaign=vue-calendar-npm) package contains date and time components such as calendar, date picker, date range picker, date time picker, and time picker. These components come with options to disable dates, restrict selection, and show custom events.

## What's Included in the Vue Calendars Package

The [Vue Calendars](https://www.syncfusion.com/vue-components/vue-calendar?utm_source=npm&utm_medium=listing&utm_campaign=vue-calendar-npm) package includes the following list of components.

### Vue Calendar

The [Vue Calendar](https://www.syncfusion.com/vue-components/vue-calendar?utm_source=npm&utm_medium=listing&utm_campaign=vue-calendar-npm) component is a graphical user interface component that displays a Gregorian or Islamic Calendar and allows selection of a date.

<p align="center">
  <a href="https://www.syncfusion.com/vue-components/vue-calendar?utm_source=npm&utm_medium=listing&utm_campaign=vue-calendar-npm">Getting Started</a> .
  <a href="https://ej2.syncfusion.com/vue/demos/?utm_source=npm&utm_medium=listing&utm_campaign=vue-calendar-npm#/bootstrap5/calendar/default.html">Online demos</a> .
  <a href="https://www.syncfusion.com/vue-components/vue-calendar?utm_source=npm&utm_medium=listing&utm_campaign=vue-calendar-npm">Learn more</a>
</p>

<p align="center">
<img alt="Vue Calendar Component" src="https://raw.githubusercontent.com/SyncfusionExamples/nuget-img/master/vue/vue-calendar.png">
</p>

#### Key features

* [Date range](https://ej2.syncfusion.com/vue/demos/?utm_source=npm&utm_campaign=calendar#/bootstrap5/calendar/date-range) - Restricts the range of dates that can be selected by using the `min` and `max` properties.
* [Customization](https://ej2.syncfusion.com/vue/demos/?utm_source=npm&utm_campaign=calendar#/bootstrap5/calendar/special-dates) - Allows complete control over the appearance of the calendar component.
* [Month or year selection](https://ej2.syncfusion.com/vue/documentation/calendar/calendar-views#calendar-views) - Provides a flexible option to select only a month or year as the date value.
* [First day of week](https://ej2.syncfusion.com/vue/documentation/calendar/how-to/change-the-first-day-of-week/#change-the-first-day-of-the-week) - Changes the first day of all weeks in every month.
* [Week number](https://ej2.syncfusion.com/vue/documentation/calendar/how-to/render-the-calendar-with-week-numbers/#render-the-calendar-with-week-numbers) - Displays the week number of the selected date in the calendar by enabling the week number option.
* [Disabled dates](https://ej2.syncfusion.com/vue/demos/?utm_source=npm&utm_campaign=calendar#/bootstrap5/calendar/disabled) - Disables any date to prevent the user from selecting that date.
* [Start and depth view](https://ej2.syncfusion.com/vue/documentation/calendar/calendar-views/#view-restriction) - Calendar has `month`, `year`, and `decade` views that provide flexibility to select dates.
* [Highlight weekends](https://ej2.syncfusion.com/vue/documentation/calendar/customization/#highlight-weekends) - The calendar supports to highlighting every weekend in a month.
* [Globalization](https://ej2.syncfusion.com/vue/documentation/calendar/globalization/#globalization) - Supports globalization (internationalization and localization) to translate the names of months, days, and the today button text to any supported language.

### Vue DatePicker

The [Vue DatePicker](https://www.syncfusion.com/vue-components/vue-datepicker?utm_source=npm&utm_medium=listing&utm_campaign=vue-calendar-npm) component is a lightweight and mobile-friendly component that allows end users to enter or select a date value. It has month, year, and decade view options to quickly navigate to the desired date. It supports minimum dates, maximum dates, and disabled dates to restrict the date selection.

<p align="center">
  <a href="https://ej2.syncfusion.com/vue/documentation/datepicker/getting-started/?utm_source=npm&utm_medium=listing&utm_campaign=vue-calendar-npm">Getting Started</a> .
  <a href="https://ej2.syncfusion.com/vue/demos/?utm_source=npm&utm_medium=listing&utm_campaign=vue-calendar-npm#/bootstrap5/datepicker/default.html">Online demos</a> .
  <a href="https://www.syncfusion.com/vue-components/vue-datepicker?utm_source=npm&utm_medium=listing&utm_campaign=vue-calendar-npm">Learn more</a>
</p>

<p align="center">
<img alt="Vue DatePicker Component" src="https://raw.githubusercontent.com/SyncfusionExamples/nuget-img/master/vue/vue-datepicker.png">
</p>

#### Key features

* [Placeholders](https://ej2.syncfusion.com/vue/documentation/datepicker/how-to/set-the-placeholder/?utm_source=npm&utm_medium=listing&utm_campaign=vue-calendar-npm) - Placeholder is a hint text that is displayed in the DatePicker; it is used to indicate the format of the date that the user should enter, such as mm/dd/yyyy or dd/mm/yyyy.
* [Mask date input](https://ej2.syncfusion.com/vue/demos/?utm_source=npm&utm_medium=listing&utm_campaign=vue-calendar-npm#/bootstrap5/datepicker/input-mask.html) - The mask date input restricts the user from typing unwanted characters in the text input, allowing only eligible date format to be typed.
* [Disabled date](https://ej2.syncfusion.com/vue/demos/?utm_source=npm&utm_medium=listing&utm_campaign=vue-calendar-npm#/bootstrap5/datepicker/disabled.html) - To disable a specific date in the picker calendar and restrict it from being set or selected in the DatePicker.
* [Date format](https://ej2.syncfusion.com/vue/demos/?utm_source=npm&utm_medium=listing&utm_campaign=vue-calendar-npm#/bootstrap5/datepicker/date-format.html) - The DatePicker control’s input value can be custom formatted apart from the default culture’s specific date format.
* [Incomplete date validation](https://ej2.syncfusion.com/vue/documentation/datepicker/strict-mode/?utm_source=npm&utm_medium=listing&utm_campaign=vue-calendar-npm) - The strictMode is an act that allows entry only of valid dates within the specified min or max range in a text box.
* [Globalization](https://ej2.syncfusion.com/vue/documentation/datepicker/globalization/?utm_source=npm&utm_medium=listing&utm_campaign=vue-calendar-npm) - Support globalization (also known as internationalization and localization) to allow you to translate the names of months, days, and other text elements in the calendar to any supported language. This can be useful in cases where you want to display the calendar in a language other than the default language.

### Vue TimePicker

The [Vue TimePicker](https://www.syncfusion.com/vue-components/vue-timepicker?utm_source=npm&utm_medium=listing&utm_campaign=vue-calendar-npm) component is a simple and intuitive interface component that allows selection of a time value from the popup list or setting a desired time value.

<p align="center">
  <a href="https://ej2.syncfusion.com/vue/documentation/timepicker/getting-started/?utm_source=npm&utm_medium=listing&utm_campaign=vue-calendar-npm">Getting Started</a> .
  <a href="https://ej2.syncfusion.com/vue/demos/?utm_source=npm&utm_medium=listing&utm_campaign=vue-calendar-npm#/bootstrap5/timepicker/default.html">Online demos</a> .
  <a href="https://www.syncfusion.com/vue-components/vue-timepicker?utm_source=npm&utm_medium=listing&utm_campaign=vue-calendar-npm">Learn more</a>
</p>

<p align="center">
<img alt="Vue TimePicker Component" src="https://raw.githubusercontent.com/SyncfusionExamples/nuget-img/master/vue/vue-timepicker.png">
</p>

#### Key features

* [Time range](https://ej2.syncfusion.com/vue/demos/?utm_source=npm&utm_campaign=timepicker#/bootstrap5/timepicker/time-range) - Restricts the entry or selection of time values within a specific range of time by using `min` and `max` properties.
* [Time format](https://ej2.syncfusion.com/vue/demos/?utm_source=npm&utm_campaign=timepicker#/bootstrap5/timepicker/time-format) - Apart from the default culture specific time format, the time picker control’s input value can also be custom formatted.
* [Strict mode](https://ej2.syncfusion.com/vue/documentation/timepicker/strict-mode#timepicker) - The strictMode is an act that allows entry of only valid time values within the specified min and max range in a text box.
* [Disabled time](https://ej2.syncfusion.com/vue/demos/?utm_source=npm&utm_campaign=timepicker#/bootstrap5/timepicker/list-formatting) - Any number of time values can be disabled in the popup list items to prevent selection of those times.
* [Time intervals](https://ej2.syncfusion.com/vue/demos/?utm_source=npm&utm_campaign=timepicker#/bootstrap5/timepicker/list-formatting) - Allows populating the time list with intervals between the times in the popup list to enable selection of proper time value.
* [Customization](https://ej2.syncfusion.com/vue/documentation/timepicker/how-to/css-customization/#css-customization) - The appearance of the time picker can be customized completely.
* [Time list with duration](https://ej2.syncfusion.com/vue/demos/?utm_source=npm&utm_campaign=timepicker#/bootstrap5/timepicker/list-formatting) - Supports customization of the control’s popup list items with time duration.
* [Mask time input](https://ej2.syncfusion.com/vue/demos/?utm_source=npm&utm_medium=listing&utm_campaign=vue-calendar-npm#/bootstrap5/timepicker/input-mask.html) - The mask time input restricts the user from typing unwanted characters in the text input, allowing only eligible time format to be typed.
* [Globalization](https://ej2.syncfusion.com/vue/documentation/timepicker/globalization#globalization) - Supports globalization (internationalization and localization) to update time popup list values to match any specified culture.

### DateTimePicker

The [Vue DateTimePicker](https://www.syncfusion.com/vue-components/vue-datetimepicker?utm_source=npm&utm_medium=listing&utm_campaign=vue-calendar-npm) component is a graphical user interface component that allows an end user to enter or select a date and time values from a pop-up calendar and time list pop-up.

<p align="center">
  <a href="https://ej2.syncfusion.com/vue/documentation/datetimepicker/getting-started/?utm_source=npm&utm_medium=listing&utm_campaign=vue-calendar-npm">Getting Started</a> .
  <a href="https://ej2.syncfusion.com/vue/demos/?utm_source=npm&utm_medium=listing&utm_campaign=vue-calendar-npm#/bootstrap5/datetimepicker/default.html">Online demos</a> .
  <a href="https://www.syncfusion.com/vue-components/vue-datetimepicker?utm_source=npm&utm_medium=listing&utm_campaign=vue-calendar-npm">Learn more</a>
</p>

<p align="center">
<img alt="Vue DateTimePicker Component" src="https://raw.githubusercontent.com/SyncfusionExamples/nuget-img/master/vue/vue-datetimepicker.png">
</p>

#### Key features

* [Date time range](https://ej2.syncfusion.com/vue/demos/?utm_source=npm&utm_campaign=datetimepicker#/bootstrap5/datetimepicker/date-time-range) - Restricts the entry or selection of values within a specific range of dates and times by using `min` and `max` properties.
* [Date time format](https://ej2.syncfusion.com/vue/demos/?utm_source=npm&utm_campaign=datetimepicker#/bootstrap5/datetimepicker/date-time-format) - The control’s input value can be custom formatted apart from the default culture’s specific date time format.
* [Mask date time input](https://ej2.syncfusion.com/vue/demos/?utm_source=npm&utm_medium=listing&utm_campaign=vue-calendar-npm#/bootstrap5/datetimepicker/input-mask.html) - The mask date time input restricts the user from typing unwanted characters in the text input, allowing only eligible date and time format to be typed.

### Vue DateRangePicker

The [Vue DateRangePicker](https://www.syncfusion.com/vue-components/vue-date-range-picker?utm_source=npm&utm_medium=listing&utm_campaign=vue-calendar-npm) component is a graphical user interface control that allows an end user to select start and end date values as a range from a calendar pop-up or by entering the value directly in the input element.

<p align="center">
  <a href="https://ej2.syncfusion.com/vue/documentation/daterangepicker/getting-started/?utm_source=npm&utm_medium=listing&utm_campaign=vue-calendar-npm">Getting Started</a> .
  <a href="https://ej2.syncfusion.com/vue/demos/?utm_source=npm&utm_medium=listing&utm_campaign=vue-calendar-npm#/bootstrap5/daterangepicker/default.html">Online demos</a> .
  <a href="https://www.syncfusion.com/vue-components/vue-date-range-picker?utm_source=npm&utm_medium=listing&utm_campaign=vue-calendar-npm">Learn more</a>
</p>

<p align="center">
<img alt="Vue DateRangePicker Component" src="https://raw.githubusercontent.com/SyncfusionExamples/nuget-img/master/vue/vue-daterangepicker.png">
</p>

#### Key features

* [Preset ranges](https://ej2.syncfusion.com/vue/demos/?utm_source=npm&utm_campaign=daterangepicker#/bootstrap5/daterangepicker/preset) - Defines the preset ranges to select the frequently used date range by the end users.
* [Range restriction](https://ej2.syncfusion.com/vue/demos/?utm_source=npm&utm_campaign=daterangepicker#/bootstrap5/daterangepicker/date-range) -This control restricts the entry or selection of values within a specific range of date by defining the min and max properties.
* [Limit the selection range](https://ej2.syncfusion.com/vue/demos/?utm_source=npm&utm_campaign=daterangepicker#/bootstrap5/daterangepicker/day-span) - Directs the end user to select only the date range with specific minimum and maximum number of days’ count by setting the minDays and maxDays options.
* [First day of week](https://ej2.syncfusion.com/vue/documentation/daterangepicker/customization#first-day-of-week) - Changes the first day of weeks in every month.
* [Strict mode](https://ej2.syncfusion.com/vue/documentation/daterangepicker/range-restriction#strict-mode) - The strictMode is an act that allows entry only of a valid date within the specified min and max range in a textbox.
* [Customization](https://ej2.syncfusion.com/vue/documentation/daterangepicker/customization#customization) - The appearance of the component can be customized completely.
* [Format](https://ej2.syncfusion.com/vue/demos/?utm_source=npm&utm_campaign=daterangepicker#/bootstrap5/daterangepicker/date-format) - The control’s input value can be custom formatted apart from the default culture’s specific date range format.
* [Globalization](https://ej2.syncfusion.com/vue/documentation/daterangepicker/globalization#globalization) - Supports globalization (internationalization and localization) to translate the names of months, days, and button text to any supported language.

<p align="center">
Trusted by the world's leading companies
  <a href="https://www.syncfusion.com/">
    <img src="https://raw.githubusercontent.com/SyncfusionExamples/nuget-img/master/syncfusion/syncfusion-trusted-companies.webp" alt="Syncfusion logo">
  </a>
</p>

## Setup

To install `calendars` and its dependent packages, use the following command.

```sh
npm install @syncfusion/ej2-vue-calendars
```

## Supported frameworks

Calendar components are also offered in the following list of frameworks.

| [<img src="https://ej2.syncfusion.com/github/images/js.svg" height="50" />](https://www.syncfusion.com/javascript-ui-controls?utm_medium=listing&utm_source=github)<br/>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[JavaScript](https://www.syncfusion.com/javascript-ui-controls?utm_medium=listing&utm_source=github)&nbsp;&nbsp;&nbsp;&nbsp; | [<img src="https://ej2.syncfusion.com/github/images/react.svg"  height="50" />](https://www.syncfusion.com/react-ui-components?utm_medium=listing&utm_source=github)<br/>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[React](https://www.syncfusion.com/react-ui-components?utm_medium=listing&utm_source=github)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; | [<img src="https://ej2.syncfusion.com/github/images/angular-new.svg"  height="50" />](https://www.syncfusion.com/angular-components/?utm_medium=listing&utm_source=github)<br/>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[Angular](https://www.syncfusion.com/angular-components/?utm_medium=listing&utm_source=github)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; | [<img src="https://ej2.syncfusion.com/github/images/netcore.svg" height="50" />](https://www.syncfusion.com/aspnet-core-ui-controls?utm_medium=listing&utm_source=github)<br/>&nbsp;&nbsp;[ASP.NET&nbsp;Core](https://www.syncfusion.com/aspnet-core-ui-controls?utm_medium=listing&utm_source=github)&nbsp;&nbsp; | [<img src="https://ej2.syncfusion.com/github/images/netmvc.svg" height="50" />](https://www.syncfusion.com/aspnet-mvc-ui-controls?utm_medium=listing&utm_source=github)<br/>&nbsp;&nbsp;[ASP.NET&nbsp;MVC](https://www.syncfusion.com/aspnet-mvc-ui-controls?utm_medium=listing&utm_source=github)&nbsp;&nbsp; | 
| :-----: | :-----: | :-----: | :-----: | :-----: |

## Support

Product support is available through following mediums.

* [Support ticket](https://support.syncfusion.com/support/tickets/create) - Guaranteed Response in 24 hours | Unlimited tickets | Holiday support
* [Community forum](https://www.syncfusion.com/forums/vue?utm_source=npm&utm_medium=listing&utm_campaign=vue-layout-npm)
* [GitHub issues](https://github.com/syncfusion/ej2-vue-ui-components/issues/new)
* [Request feature or report bug](https://www.syncfusion.com/feedback/vue?utm_source=npm&utm_medium=listing&utm_campaign=vue-layout-npm)
* Live chat

## Changelog

Check the changelog [here](https://github.com/syncfusion/ej2-vue-ui-components/blob/master/components/calendars/CHANGELOG.md). Get minor improvements and bug fixes every week to stay up to date with frequent updates.

## License and copyright

> This is a commercial product and requires a paid license for possession or use. Syncfusion’s licensed software, including this component, is subject to the terms and conditions of Syncfusion's [EULA](https://www.syncfusion.com/eula/es/). To acquire a license for 80+ [Vue UI components](https://www.syncfusion.com/vue-components), you can [purchase](https://www.syncfusion.com/sales/products) or [start a free 30-day trial](https://www.syncfusion.com/account/manage-trials/start-trials).

> A free community [license](https://www.syncfusion.com/products/communitylicense) is also available for companies and individuals whose organizations have less than $1 million USD in annual gross revenue and five or fewer developers.

See [LICENSE FILE](https://github.com/syncfusion/ej2-vue-ui-components/blob/master/license) for more info.

© Copyright 2025 Syncfusion<sup>®</sup> Inc. All Rights Reserved. The Syncfusion<sup>®</sup> Essential Studio<sup>®</sup> license and copyright applies to this distribution.